
let source = GetCurrentScriptDirectory~"/source/Stage/";

let stbg1 = source~"stg0bg1.png";
let stbg2 = source~"stg0bg2.png";
let stbg3 = source~"stg1bg3.png";
let stbg4 = source~"stg1bg4.png";
let stgspeed = 5;
let SpellActive = false;

@Initialize{
	SetAutoDeleteObject(true);
	Stage1Bg;
}
@MainLoop{
	yield;
}

task Stage1Bg{
	let StageBG1;
	let StageBG2;
	let StageBG3;
	let StageBGSky;
	let ypos = 0;
	let osize = 0;
	
	
	SetCameraFocusX(0);
	SetCameraFocusY(0);
	SetCameraFocusZ(100);
	SetCameraRadius(300);
	SetCameraElevationAngle(300);
	SetCameraAzimuthAngle(90);		
	
	StageBG1 = ObjPrim_Create(OBJ_SPRITE_3D);
	let bg1size = 256;
	ObjRender_SetBlendType(StageBG1, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBG1, 255);
	ObjPrim_SetTexture(StageBG1, stbg1);
	ObjSprite3D_SetSourceRect(StageBG1, 0, ypos, bg1size*6, ypos+bg1size*6);
	ObjSprite3D_SetDestRect(StageBG1, -bg1size*2.5, -48, bg1size*2.5, bg1size*4);
	ObjRender_SetZWrite(StageBG1, true);
	ObjRender_SetZTest(StageBG1, true);
	
	
	StageBG2 = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBG2, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBG2, 64);
	ObjPrim_SetTexture(StageBG2, stbg2);
	ObjSprite3D_SetSourceRect(StageBG2, 0, 0, bg1size*4, bg1size*4);
	ObjSprite3D_SetDestRect(StageBG2, -bg1size*2, -bg1size/2, bg1size*2, bg1size*4);
	ObjRender_SetZWrite(StageBG2, true);
	ObjRender_SetZTest(StageBG2, true);	
	
	StageBG3 = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBG3, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBG3, 64);
	ObjPrim_SetTexture(StageBG3, stbg2);
	ObjSprite3D_SetSourceRect(StageBG3, 0, 0, bg1size*4, bg1size*4);
	ObjSprite3D_SetDestRect(StageBG3, -bg1size*2, -bg1size/2, bg1size*2, bg1size*4);
	ObjRender_SetZWrite(StageBG3, true);
	ObjRender_SetZTest(StageBG3, true);	
	
	StageBGSky = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBGSky, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBGSky, 255);
	ObjPrim_SetTexture(StageBGSky, NULL);
	ObjSprite3D_SetSourceRect(StageBGSky, 0, 0, 0, 0);
	ObjSprite3D_SetDestRect(StageBGSky, -bg1size*2.5, 0, bg1size*2.5, bg1size*4);
	ObjRender_SetZWrite(StageBGSky, true);
	ObjRender_SetZTest(StageBGSky, true);
	
	ObjRender_SetPosition(StageBG1, 0, 0, -80);
	Obj_SetRenderPriority(StageBG1, 0.72);
	
	ObjRender_SetPosition(StageBG2, 0, 0, -75);
	ObjRender_SetAngleXYZ(StageBG2, 0, 0, 30);
	Obj_SetRenderPriority(StageBG2, 0.72);
	ObjRender_SetZTest(StageBG2, false);
	
	ObjRender_SetPosition(StageBG3, 0, 0, -75);
	ObjRender_SetAngleXYZ(StageBG3, 0, 0, 330);
	Obj_SetRenderPriority(StageBG3, 0.72);
	ObjRender_SetZTest(StageBG3, false);
	
	ObjRender_SetPosition(StageBGSky, 0, 700, -300);
	ObjRender_SetAngleXYZ(StageBGSky, 90, 0, 0);
	Obj_SetRenderPriority(StageBGSky, 0.72);
		
	SetFogEnable(true);
	SetFogParam(600, 900, 104, 112, 144);
	CreateBrushGroupA1;
	CreateStairs;
	
	while(!GetCommonData("SelectionSet", false)){RenderBG;yield;}
	Obj_SetRenderPriority(StageBG1, 0.22);
	Obj_SetRenderPriority(StageBG2, 0.22);
	Obj_SetRenderPriority(StageBG3, 0.22);
	Obj_SetRenderPriority(StageBGSky, 0.22);
	while(GetCommonData("quality", 2)!=0){
		RenderBG;
		yield;
	}
	Obj_Delete(StageBG1);
	Obj_Delete(StageBG2);
	Obj_Delete(StageBG3);
	Obj_Delete(StageBGSky);
	CloseScript(GetOwnScriptID);
	sub RenderBG{
		SetCameraFocusX(cos(osize)*75); // Remove these two lines
		SetCameraAzimuthAngle(sin(osize)*5+90);	// for static camera
		ObjRender_SetAngleXYZ(StageBG1, 0, 0, cos(osize)*5);
		ObjSprite3D_SetSourceRect(StageBG1, ypos, 0, ypos+bg1size*6, bg1size*6);
		ObjSprite3D_SetSourceRect(StageBG2, ypos/2, 0, ypos/2+bg1size*4, bg1size*4);
		ObjSprite3D_SetSourceRect(StageBG3, -ypos/2, 0, -ypos/2+bg1size*4, bg1size*4);
		ypos+=stgspeed;
		osize += 0.65;
		if(ypos > 512){ypos = 0}
		if(osize >= 360){osize = 1;}
	}
}

task CreateStairs{
	return;
	let obj = ObjMesh_Create();
	ObjMesh_Load(obj, source~"Netherworld_Stairs.mqo");
	ObjMesh_SetColor(obj, 255, 255, 255);
	
	let locpos = [rand(-15, 15), rand(100,100), rand(48, 52)];
	let locpoi = [rand(0.15, 1.2), -rand(0.15, 2.5), -rand(3, 7)];
	let locang = [rand(0, 360), rand(0, 360), rand(0, 360)];
	let locasp = [rand(-1, 1), rand(-1, 1), rand(-1, 1)]; 
	
	let dspin = 0;
	
	ObjRender_SetPosition(obj, locpos[0], locpos[1], locpos[2]);
	ObjRender_SetAngleXYZ(obj, 90, 0, 90);
	ObjRender_SetScaleXYZ(obj, rand(0.35, 0.75), rand(0.35, 0.75), rand(0.35, 0.75));
	Obj_SetRenderPriority(obj, 0.21);
	
	while(locpos[2] > 0||true){
		locpos+=locpoi;
		locang+=locasp;
		//ObjRender_SetPosition(obj, locpos[0], locpos[1], locpos[2]);
		yield;
	}
	Obj_Delete(obj);
}

task CreateBrushGroupA1{
	loop{
		CreateLeafA1;
		loop(6){yield};
	}
}
task CreateBrushGroupA2{
	loop{
		//CreateRainA1;
		loop(9){yield};
	}
}

task CreateLeafA1{
	let leaf = Create3DBrush(255, 32, 0, stbg3, 0.23);
	ObjSprite3D_SetDestRect(leaf, -16, -16, 16, 16);
	let locpos = [rand(-450, 450), rand(300,700), rand(128, 208)];
	let locang = [rand(0,360), rand(0,360), rand(0,360)];
	let locasp = [rand(-3, 3), rand(-3, 3), rand(-3, 3)];
	let alpha = 0;
	let etime = 140;
	locpos[0] = locpos[0]-32;
	ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
	ObjRender_SetAngleXYZ(leaf, locang[0], locang[1], locang[2]);
	ObjRender_SetScaleXYZ(leaf, 0.5, 0.5, 0.5);
	ObjRender_SetColor(leaf, 164, 164, 196);
	Obj_SetRenderPriority(leaf, 0.22);
	if(!GetCommonData("SelectionSet", false)){Obj_SetRenderPriority(leaf, 0.72);}
	
	while(etime > 0){
		etime--;
		alpha = min(alpha + 2, 128);
		UpdatePosition;
		yield;
	}
	while(alpha > 0){
		alpha = max(alpha - 2.5, 0);
		UpdatePosition;
		yield;
	}
	Obj_Delete(leaf);
	sub UpdatePosition{
		locpos[0]=locpos[0]-stgspeed/4;
		locpos[1]=locpos[1]-stgspeed/2;
		locpos[2]=locpos[2]-stgspeed/5;
		locang[0]=locang[0]+locasp[0];
		locang[1]=locang[1]+locasp[1];
		locang[2]=locang[2]+locasp[2];
		ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
		ObjRender_SetAngleXYZ(leaf, locang[0], locang[1], locang[2]);
		ObjRender_SetAlpha(leaf, alpha);
	}
}




function Create3DBrush(alpha, srcrect, offset, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0+offset, 0+offset, srcrect+offset, srcrect+offset);
	ObjSprite3D_SetDestRect(StageProp, 0, -srcrect/2, srcrect, srcrect/2); // Centered middle origin maybe
	//ObjRender_SetZWrite(StageProp, true);
	//ObjRender_SetZTest(StageProp, true);
	return StageProp;
}
function Create3DProperties(alpha, srcrect, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect, srcrect);
	ObjSprite3D_SetDestRect(StageProp, -srcrect, -srcrect, srcrect, srcrect);
	ObjRender_SetZWrite(StageProp, true);
	ObjRender_SetZTest(StageProp, true);
	return StageProp;
}



task CameraFlight{
	// Static Version
	let pos = [0,0,100];
	let ang = [90,295,300];
	let cammod = 1.25;
	loop{
		if(GetKeyState(KEY_J)==KEY_HOLD){pos[0]=pos[0]+5*cammod;}
		if(GetKeyState(KEY_L)==KEY_HOLD){pos[0]=pos[0]-5*cammod;}
		if(GetKeyState(KEY_I)==KEY_HOLD){pos[1]=pos[1]+5*cammod;}
		if(GetKeyState(KEY_K)==KEY_HOLD){pos[1]=pos[1]-5*cammod;}
		if(GetKeyState(KEY_U)==KEY_HOLD){pos[2]=pos[2]-5*cammod;}
		if(GetKeyState(KEY_O)==KEY_HOLD){pos[2]=pos[2]+5*cammod;}
		
		
		if(GetKeyState(KEY_Q)==KEY_HOLD){ang[0]=ang[0]+2*cammod;}
		if(GetKeyState(KEY_E)==KEY_HOLD){ang[0]=ang[0]-2*cammod;}
		if(GetKeyState(KEY_W)==KEY_HOLD){ang[1]=ang[1]+2*cammod;}
		if(GetKeyState(KEY_S)==KEY_HOLD){ang[1]=ang[1]-2*cammod;}
		if(GetKeyState(KEY_A)==KEY_HOLD){ang[2]=ang[2]+2*cammod;}
		if(GetKeyState(KEY_D)==KEY_HOLD){ang[2]=ang[2]-2*cammod;}
		
		SetCameraFocusX(pos[0]);
		SetCameraFocusY(pos[1]);
		SetCameraFocusZ(pos[2]);
		SetCameraAzimuthAngle(ang[0]);	
		SetCameraElevationAngle(ang[1]);
		SetCameraRadius(ang[2]);
		yield;
	}
}


