
let MainSTG = GetMainStgScriptDirectory;
let img_effect = MainSTG~"ds_system/img/effect.png"; // Effect Sheet

task StarOnBoss(objID, com1X, com2Y){ 
	
	let objxpos = -400;
	let objypos = -400;
	let obj_angle = 0;
	let osize = 0;
	let oshift = 0;
	let mspd = 0.15;

	ObjRender_SetBlendType(objID, BLEND_ALPHA);
	Obj_SetRenderPriority(objID, 0.3);
	ObjPrim_SetTexture(objID, img_effect);
	ObjSprite2D_SetSourceRect(objID, 128, 80, 256, 208);
	ObjSprite2D_SetDestRect(objID, -64, -64, 64, 64);
	ObjRender_SetAlpha(objID, 145);
	ObjRender_SetColor(objID, 255,200,200);
	
	ascent(i in 0..60){
		obj_angle = max(obj_angle-6+min(i/9.75, 6), -180);
		osize = min(osize+0.075-i/1850, 1.7);
		UpdateStar;
		yield;
	}
	loop(5){yield;}
	while(!Obj_IsDeleted(objID)){
		mspd = min(mspd+0.03, 1);
		obj_angle-=5*mspd;
		oshift+=2.631*mspd;
		UpdateStar;
		yield;
	}
	sub UpdateStar{
		objxpos = GetCommonData(com1X, -400);
		objypos = GetCommonData(com2Y, -400);		
		ObjRender_SetPosition(objID, objxpos, objypos, 0);
		ObjRender_SetScaleXYZ(objID, osize+0.25*sin(oshift), osize+0.25*sin(oshift), 1);
		ObjRender_SetAngleZ(objID, obj_angle);
		//ObjRender_SetAngleXYZ(objID, osize+30*cos(oshift+180), osize+30*sin(oshift+180), obj_angle); heh
	}
	
}




task StarOnBossA2(objID, com1X, com2Y){ 
	
	let objxpos = -400;
	let objypos = -400;
	let obj_angle = 0;
	let osize = 0;
	let oshift = 0;
	let mspd = 0.15;

	ObjRender_SetBlendType(objID, BLEND_ALPHA);
	Obj_SetRenderPriority(objID, 0.3);
	ObjPrim_SetTexture(objID, img_effect);
	ObjSprite2D_SetSourceRect(objID, 128, 80, 256, 208);
	ObjSprite2D_SetDestRect(objID, -64, -64, 64, 64);
	ObjRender_SetAlpha(objID, 145);
	ObjRender_SetColor(objID, 255,200,200);
	ObjRender_SetScaleXYZ(objID, 2.25, 2.25, 1);
	
	ascent(i in 0..60){
		obj_angle = max(obj_angle-6+min(i/9.75, 6), -180);
		osize = min(osize+0.075-i/1850, 1.7);
		UpdateStar;
		yield;
	}
	loop(5){yield;}
	while(!Obj_IsDeleted(objID)){
		mspd = min(mspd+0.03, 1);
		obj_angle-=0.75*mspd;
		oshift+=2.631*mspd;
		UpdateStar;
		yield;
	}
	sub UpdateStar{
		objxpos = GetCommonData(com1X, -400);
		objypos = GetCommonData(com2Y, -400);		
		ObjRender_SetPosition(objID, objxpos, objypos, 0);
		//ObjRender_SetScaleXYZ(objID, osize+0.25*sin(oshift), osize+0.25*sin(oshift), 1);
		ObjRender_SetAngleXYZ(objID, 48, 32*cos(obj_angle), obj_angle+45);
	}
	
}

function GetTrueAngle(value){
	while(value<-360){value+=360;}
	while(value> 360){value-=360;}
	return value;
}



task StarOnBossOld(objID, com1X, com2Y){ 
	
	let StarX = -400;
	let StarY = -400;
	
	let objxpos=StarX;
	let objypos=StarY;
	let object_time = 30;
	let obj_angle = 330;
	let osize = 0;
	let obj_sizeset = 0;
	let sizeinc = 5;
	let angleinc = 5;
	let fullsize = 0;

	ObjRender_SetBlendType(objID, BLEND_ALPHA);
	Obj_SetRenderPriority(objID, 0.3);
	ObjPrim_SetTexture(objID, img_effect);
	ObjSprite2D_SetSourceRect(objID, 128, 80, 256, 208);
	ObjSprite2D_SetDestRect(objID, -64, -64, 64, 64);
	
	
	ObjRender_SetAlpha(objID, 145);
	ObjRender_SetColor(objID, 32,32,255);
	
	while(!Obj_IsDeleted(objID)){

		objxpos = GetCommonData(com1X, -400);
		objypos = GetCommonData(com2Y, -400);
		
		StarSize;
		ObjRender_SetX(objID, objxpos);
		ObjRender_SetY(objID, objypos);
		ObjRender_SetScaleXYZ(objID, osize/95, osize/95, 1);
		ObjRender_SetAngleZ(objID, obj_angle);
		yield;
	}
	
	task StarSize{
		let ax2 = 0.04;
		let bx2 = 1.35;
		if(fullsize==2){
			if(obj_sizeset==0){sizeinc+=ax2}
			if(obj_sizeset==1){sizeinc-=ax2}
			
			if(sizeinc<-bx2){obj_sizeset=0}
			if(sizeinc>bx2){obj_sizeset=1}
			
			obj_angle-=angleinc;
			
			if(angleinc<5){angleinc+=0.5}else{angleinc=5;}
			
			osize+=sizeinc;
		}
		if(fullsize!=2){obj_angle-=angleinc;angleinc-=0.06;}
		if(osize<145&&fullsize==0){osize+=5;}
		if(osize>144&&fullsize==0){
			fullsize=1;
			loop(55){yield;}
			sizeinc=0;
			angleinc=0;
			fullsize=2;
		}			
	}	
}



